
package trafficlighttest;

public class EW extends State {
    //Names of the lanes
    private static final int NORTHLEFT = 0;
    private static final int SOUTHLEFT = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;
    private static final int EASTLEFT = 4;
    private static final int WESTLEFT = 5;
    private static final int EAST = 6;
    private static final int WEST = 7;

    public EW() {
    }
    
    /* sendCars 
     * For EW, sends the cars from lanes east and west through the intersection
     */
    @Override
    public void sendCars(Lane[] lanes){
        int now1 = lanes[EAST].getCurrentCars();
        int now2 = lanes[WEST].getCurrentCars();
        for (int i = 0; i < now1; i++) {
            lanes[EAST].sendCar();
        }
        
        for (int i = 0; i < now2; i++) {
            lanes[WEST].sendCar();
        }
    }
    
    /* incrementWaits
     * For EW, increments the waits of cars of all lanes but east and west
     */
    @Override
    public void incrementWaits(Lane[] lanes) {
        lanes[NORTHLEFT].incrementWaits();
        lanes[NORTH].incrementWaits();
        lanes[SOUTHLEFT].incrementWaits();
        lanes[SOUTH].incrementWaits();
        lanes[EASTLEFT].incrementWaits();
        lanes[WESTLEFT].incrementWaits();
    }
}
