
package trafficlighttest;

public class EWL extends State {
    //Names of the lanes
    private static final int NORTHLEFT = 0;
    private static final int SOUTHLEFT = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;
    private static final int EASTLEFT = 4;
    private static final int WESTLEFT = 5;
    private static final int EAST = 6;
    private static final int WEST = 7;

    public EWL() {
    }

    /* sendCars
     * For EWL, sends the cars from lanes eastleft and westleft through the intersection
     */
    @Override
    public void sendCars(Lane[] lanes){
        int now1 = lanes[EASTLEFT].getCurrentCars();
        int now2 = lanes[WESTLEFT].getCurrentCars();
        for (int i = 0; i < now1; i++) {
            lanes[EASTLEFT].sendCar();
        }
        
        for (int i = 0; i < now2; i++) {
            lanes[WESTLEFT].sendCar();
        }
    }
    
    /* incrementWaits
     * For EWL, increments the waits of all lanes but eastleft and westleft
     */
    @Override
    public void incrementWaits(Lane[] lanes) {
        lanes[NORTHLEFT].incrementWaits();
        lanes[NORTH].incrementWaits();
        lanes[EAST].incrementWaits();
        lanes[WEST].incrementWaits();
        lanes[SOUTHLEFT].incrementWaits();
        lanes[SOUTH].incrementWaits();
    }
}
