
package trafficlighttest;

public class Lane {
    //The names of all the lanes
    private static final int NORTHLEFT = 0;
    private static final int NORTH = 1;
    private static final int EASTLEFT = 2;
    private static final int EAST = 3;
    private static final int SOUTHLEFT = 4;
    private static final int SOUTH = 5;
    private static final int WESTLEFT = 6;
    private static final int WEST = 7;
    private int direction, totalWait, averageWait, worstWait, totalCars, currentCars;
    public Queue cars;

    public Lane(int direction) {
        this.direction = direction;
        this.totalWait = 0;
        this.averageWait = 0;
        this.worstWait = 0;
        this.totalCars = 0;
        this.currentCars = 0;
        this.cars = new Queue();
    }
    
    public int getDirection(){
        return this.direction;
    }

    public int getAverageWait() {
        if (totalCars != 0){
            averageWait = totalWait / totalCars;
        return averageWait;
        }
        return -1;
    }

    public int getWorstWait() {
        return this.worstWait;
    }
    
    public int getTotalCars() {
        return this.totalCars;
    }
    
    public int getCurrentCars() {
        return this.currentCars;
    }
    
    public void addCar(int mode) {
        if (mode != this.direction / 2) {
            this.cars.enqueue(new Car());
            this.currentCars++;
            this.totalCars++;
            return;
        }
        System.out.printf("Car passing through lane %d with no wait...\n", this.direction);
        this.totalCars++;   
    }
    
    public void sendCar() {
        int wait = this.cars.dequeue();
        if (wait > this.worstWait) {
            this.worstWait = wait;
        }
        this.totalWait += wait;
        this.currentCars--;
        System.out.printf("Sending a car from lane %d...\n", this.direction);
        return;
    }
    
    public void incrementWaits() {
        cars.incrementWaits();
    }
}
