
package trafficlighttest;

public class NS extends State {
    //Names of the lanes
    private static final int NORTHLEFT = 0;
    private static final int SOUTHLEFT = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;
    private static final int EASTLEFT = 4;
    private static final int WESTLEFT = 5;
    private static final int EAST = 6;
    private static final int WEST = 7;

    public NS() {
    }

    /* sendCars
     * For NS, send cars sends the north and south lanes' cars through the intersection
     */
    @Override
    public void sendCars(Lane[] lanes){
        int now1 = lanes[NORTH].getCurrentCars();
        int now2 = lanes[SOUTH].getCurrentCars();
        for (int i = 0; i < now1; i++) {
            lanes[NORTH].sendCar();
        }
        
        for (int i = 0; i < now2; i++) {
            lanes[SOUTH].sendCar();
        }
    }
    
    /* incrementWaits
     * For NS, increments the waits of all lanes but north and south
     */
    @Override
    public void incrementWaits(Lane[] lanes) {
        lanes[NORTHLEFT].incrementWaits();
        lanes[EASTLEFT].incrementWaits();
        lanes[EAST].incrementWaits();
        lanes[SOUTHLEFT].incrementWaits();
        lanes[WESTLEFT].incrementWaits();
        lanes[WEST].incrementWaits();
    }
}
