
package trafficlighttest;

public class NSL extends State {
    //Names of the lanes
    private static final int NORTHLEFT = 0;
    private static final int SOUTHLEFT = 1;
    private static final int NORTH = 2;
    private static final int SOUTH = 3;
    private static final int EASTLEFT = 4;
    private static final int WESTLEFT = 5;
    private static final int EAST = 6;
    private static final int WEST = 7;

    public NSL() {     
    }
  
    /* sendCars
     * For NSL, sends the cars from lanes northleft and southleft through the intersection
     */
    @Override
    public void sendCars(Lane[] lanes){
        int now1 = lanes[NORTHLEFT].getCurrentCars();
        int now2 = lanes[SOUTHLEFT].getCurrentCars();
        for (int i = 0; i < now1; i++) {
            lanes[NORTHLEFT].sendCar();
        }
        
        for (int i = 0; i < now2; i++) {
            lanes[SOUTHLEFT].sendCar();
        }
    }
    
    /* incrementWaits
     * For NSL, increments the waits of cars of all lanes but northleft and southleft
     */
    @Override
    public void incrementWaits(Lane[] lanes) {
        lanes[NORTH].incrementWaits();
        lanes[EASTLEFT].incrementWaits();
        lanes[EAST].incrementWaits();
        lanes[WESTLEFT].incrementWaits();
        lanes[WEST].incrementWaits();
        lanes[SOUTH].incrementWaits();
    }
}
