
package trafficlighttest;

public class Queue {
    private Node head;
    private int length;

    public Queue() {
        this.head = null;
        this.length = 0;
    }
    
    /* Adds a car to the queue
     *
     * vehicle = the car to be added to the queue
     */
    public void enqueue(Car vehicle){
        //Special case: empty queue
        //Make the car the head
        if (this.length == 0){
            this.head = new Node(vehicle);
            this.length++;
            return;
        }
        
        Node current = head;
        Node newNode = new Node(vehicle);
        while (current.next != null){
            current = current.next;
        }
        current.next = newNode;
        this.length++;
    }
    
    /* Removes the first car in the queue and returns its wait time
     *
     */
    public int dequeue(){
        //Special case: empty queue
        //Return signal value -1
        if (this.length == 0){
            return -1;
        }
        //Special case: Length of 1
        //Make head null to indicate empty queue
        if (this.length == 1){
            int wait = this.head.getCarWait();
            head = null;
            this.length--;
            return wait;
        }
        
        Node exiting = head;
        head = head.next;
        this.length--;
        return exiting.getCarWait();
    }
    
    public int getLength() {
        return this.length;
    }
    
    public void incrementWaits() {
        if (this.head == null) {
            return;
        }
        Node current = this.head;
        while (current.next != null){
            current.data.incrementWait();
            current = current.next;
        }
    }
}
