
package trafficlighttest;

public class TrafficLightTest {

    public static void main(String[] args) {
        //Create and array and set the value in each spot to 1
        //because 1 means that lane will exist
        int[] lanesInit = new int[8];
        for (int i = 0; i < lanesInit.length; i++) {
            lanesInit[i] = 1;
        }
        
        //Create an intersection with all 8 possible lanes
        Intersection test = new Intersection(lanesInit);
        
        //Add rules
        //Lane 0 (north left turning) needs more than 2 cars to get a green
        test.addRule(0, 2);
        //Lane 1 (north straight) needs more than 4 to get a green, etc
        test.addRule(1, 3);
        test.addRule(2, 4);
        test.addRule(3, 3);
        test.addRule(4, 3);
        test.addRule(5, 7);
        test.addRule(6, 4);
        test.addRule(7, 4);
        
        //Test with 25 cars
        //Step controls everything, even adds cars to random lanes
        for (int i = 0; i < 100; i++) {
            test.step();
        }
        
        //Print stats
        System.out.println("\nSIMULATION STATISTICS:");
        System.out.println("Average waits: ");
        int[] avg = test.getAverageWaits();
        for (int i = 0; i < avg.length; i++) {
            System.out.printf("Lane %d: %d\n", i, avg[i]);
        }
        System.out.println();
        System.out.println("Worst waits: ");
        int[] worst = test.getWorstWaits();
        for (int i = 0; i < worst.length; i++) {
            System.out.printf("Lane %d: %d\n", i, worst[i]);
        }
        System.out.println();
        System.out.println("Total cars for each lane:");
        int[] total = test.getTotalCars();
        for (int i = 0; i < total.length; i++) {
            System.out.printf("Lane %d: %d cars\n", i, total[i]);
        }
    }
}
    

